<template>
    <transition :name="transitionName" mode="out-in">
        <div v-if="isActive" class="tab-content" :class="{'disabled': disabled}">
            <div class="features w-full flex justify-start mb-4">
                <slot name="features"></slot>
            </div>
            <slot></slot>
            <div class="w-full flex justify-center mb-4">
                <slot name="action">
                    <!-- Default Action -->
                    <button class="cta-button">Take Me To</button>
                </slot>
            </div>
            <slot name="alert"></slot>
        </div>
    </transition>
</template>

<script lang='ts'>
import Vue from 'vue'
import Component from 'vue-class-component'
import { Prop } from 'vue-property-decorator'
import TabGroup from './TabGroup.vue'

@Component({
    name: 'TabItem',
})
export default class App extends Vue {
    // Props
    @Prop({ default: '' }) readonly label: string | undefined
    @Prop({ default: false }) readonly disabled: boolean | undefined

    // Lifecycles
    created() {
        const parent = this.$parent as TabGroup
        if (!parent.$data._isTabGroup) {
            this.$destroy()
            throw new Error('Please wrap TabItem with TabGroup')
        }
        parent.refreshSlots()
    }

    beforeDestroy() {
        const parent = this.$parent as TabGroup
        parent.refreshSlots()
    }

    // Data
    // Internally used to confirm that TabItem is infact an instance of itself
    _isTabItem = true
    isActive = false
    transitionName: string | null = null

    // Methods
    activate(oldIndex: number, newIndex: number) {
        this.transitionName = newIndex < oldIndex ? 'slide-right' : 'slide-left'
        this.isActive = true
    }

    deactivate(oldIndex: number, newIndex: number) {
        this.transitionName = newIndex < oldIndex ? 'slide-right' : 'slide-left'
        this.isActive = false
    }
}
</script>

<style lang="css" scoped>
.slide-right-enter-active,
.slide-right-leave-active {
    transition: all 200ms cubic-bezier(0.4, 0, 0.2, 1);
}
.slide-right-enter,
.slide-right-leave-to {
    transform: translateX(-2000px);
    opacity: 0;
    width: 100vw;
    position: absolute;
}

.slide-left-enter-active,
.slide-left-leave-active {
    transition: all 200ms cubic-bezier(0.4, 0, 0.2, 1);
}
.slide-left-enter,
.slide-left-leave-to {
    transform: translateX(2000px);
    opacity: 0;
    width: 100vw;
    position: absolute;
}
</style>